import { i18n } from '@/i18n/setupI18n';
<%_ if (enableTranslation) { _%>
import { allEnums } from '@/models/enumerations/all-enums';
<%_ } _%>

// begcode-please-regenerate-this-file 如果您不希望重新生成代码时被覆盖，将please修改为don't ！！！


type I18nGlobalTranslation = {
  (key: string): string;
  (key: string, locale: string): string;
  (key: string, locale: string, list: unknown[]): string;
  (key: string, locale: string, named: Record<string, unknown>): string;
  (key: string, list: unknown[]): string;
  (key: string, named: Record<string, unknown>): string;
};
<%_ if (enableTranslation) { _%>

type getEnumDictType = {
  (enumType: any): any[];
};
<%_ } _%>

type I18nTranslationRestParameters = [string, any];

function getKey(namespace: string | undefined, key: string) {
  if (!namespace) {
    return key;
  }
  if (key.startsWith(namespace)) {
    return key;
  }
  return `${namespace}.${key}`;
}

export function useI18n(namespace?: string): {
  t: I18nGlobalTranslation;
<%_ if (enableTranslation) { _%>
  getEnumDict: getEnumDictType;
<%_ } _%>
} {
  const normalFn = {
    t: (key: string) => {
      return getKey(namespace, key);
    },
<%_ if (enableTranslation) { _%>
    getEnumDict: (enumType: any) => {
      const enumDictKeys = allEnums[enumType];
      const result: any[] = [];
      Object.keys(enumDictKeys).forEach(key => {
        result.push({ label: key, value: key });
      });
      return result;
    },
<%_ } _%>
  };

  if (!i18n) {
    return normalFn;
  }

  const { t, ...methods } = i18n.global;

  const tFn: I18nGlobalTranslation = (key: string, ...arg: any[]) => {
    if (!key) return '';
    if (!key.includes('.') && !namespace) return key;
    return (t as (arg0: string, ...arg: I18nTranslationRestParameters) => string)(
      getKey(namespace, key),
      ...(arg as I18nTranslationRestParameters),
    );
  };
<%_ if (enableTranslation) { _%>
  const getEnumDict = (enumType: any) => {
    const enumDictKeys = allEnums[enumType];
    const result: any[] = [];
    Object.keys(enumDictKeys).forEach(key => {
      result.push({ label: tFn(`<%= frontendAppName %>.${enumType}.` + key), value: key });
    });
    return result;
  };
<%_ } _%>
  return {
    ...methods,
    t: tFn,
<%_ if (enableTranslation) { _%>
    getEnumDict,
<%_ } _%>
  };
}

// Why write this function？
// Mainly to configure the vscode i18nn ally plugin. This function is only used for routing and menus. Please use useI18n for other places

// 为什么要编写此函数？
// 主要用于配合vscode i18nn ally插件。此功能仅用于路由和菜单。请在其他地方使用useI18n
export const t = (key: string) => key;
